//---------------------------------------------------------------------------


#pragma hdrstop


#include <Dialogs.hpp>
#include "MyAdminSession.h"
#include "IceUtil/UUID.h"
#include "MyObjcetObserver.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

MyAdminSession::MyAdminSession(TForm1 *frm)
{
	this->LogForm = frm;

	this->_communicator = NULL;

	this->_adapter = NULL;

	this->_session = NULL;

	this->_admin = NULL;

}

MyAdminSession::~MyAdminSession()
{
	this->LogOut();
}

bool MyAdminSession::destroyCommunicator()
{
	if (this->_communicator == NULL) {
        	return true;
	}

	try{
    	this->_communicator->destroy();

	}catch (const IceUtil::Exception & ex){
    	return false;
	}catch (...){
    	return false;
	}

    this->_communicator =  NULL;

	return true;

}

bool MyAdminSession::LogIn(AnsiString username, AnsiString password, AnsiString endpoint)
{
	this->_username = username;
	this->_password = password;
	this->_endpoint = endpoint;


	try{
        int argc = 0;
		char **argv = NULL;
		this->_communicator =  Ice::initialize(argc, argv);

		Ice::Identity locatorId ;

		locatorId.category = "EasyIceGrid";
		locatorId.name = "Locator";

		std::string str= "\"" ;
//    	std::string str = "";
		str = str + this->_communicator->identityToString(locatorId)+ "\"";
		str += ":" + std::string(endpoint.c_str());

//		str = "EasyIceGrid/Locator -t:tcp -h 168.168.241.52 -p 4061";

		ShowMessage("   str--1:" + AnsiString(str.c_str()));

//		return true;

		IceGrid::RegistryPrx currentRegistry = NULL;

		//ShowMessage("2");

//		str = "EasyIceGrid/Locator -t:tcp -h 168.168.241.52 -p 4061";

		defaultLocator = IceGrid::LocatorPrx::checkedCast(this->_communicator->stringToProxy(str));

        //ShowMessage("3");

		if( defaultLocator == NULL ){
			ShowMessage("   invalid:This version of IceGrid Admin requires an IceGrid Registry version 3.2 or higher");
        	return false;
		}

		//ShowMessage("4");

		currentRegistry = defaultLocator->getLocalRegistry();

			//ShowMessage("5");

		
		currentRegistry = IceGrid::RegistryPrx::uncheckedCast(currentRegistry->ice_endpoints(defaultLocator->ice_getEndpoints()));
				//ShowMessage("6");
		this->_communicator->setDefaultLocator(defaultLocator);

		ShowMessage("   bb:" + AnsiString(currentRegistry->ice_getIdentity().name.c_str()));

			//ShowMessage("7");
		 registry = currentRegistry;

		if( ! (currentRegistry->ice_getIdentity().name == "Registry") ){
			Ice::Identity   masterRegistryId;
			
			masterRegistryId.category = "EasyIceGrid";;
			masterRegistryId.name = "Registry";

			registry = RegistryPrx::
                    uncheckedCast(_communicator->stringToProxy(
                                      "\"" + _communicator->identityToString(masterRegistryId) + "\""));
			
		}

		this->_session = registry->createAdminSession(std::string(username.c_str()), std::string(password.c_str()) );
          	//ShowMessage("8");
		if( this->_session == NULL)
		{
			//ShowMessage("   session is NULL");
			return false;
		}

	   //	this->_session->keepAlive();

		//ShowMessage("9");

		this->_keepaliveperiod = registry->getSessionTimeout() * 1000 / 2;

		//ShowMessage(AnsiString(this->_keepaliveperiod));

//
		if(registry == currentRegistry)
		{
			this->_session = IceGrid::AdminSessionPrx::uncheckedCast( this->_session->ice_endpoints(currentRegistry->ice_getEndpoints()));
		}

		 //ShowMessage("10");
	}catch(const Ice::LocalException &e){
		ShowMessage("   local");

	}catch (const IceUtil::Exception & ex){
		ShowMessage(" xxx ");
		return false;
	}catch (...){
		ShowMessage(" eee ");
    	return false;
	}


	return this->registerObservers();
	
}

bool MyAdminSession::registerObservers()
{

	////ShowMessage("comt to registerObservers--1");
	try{
		this->_admin = this->_session->getAdmin();

		////ShowMessage("comt to registerObservers--2");

		//create thread to keepalive
		////todo

		//register observers
		
		 std::string category = "observer1";

		 ////ShowMessage("comt to registerObservers--3");

//		 this->_adapter =this->_communicator->createObjectAdapter("");

		 this->_adapter = this->_communicator->createObjectAdapterWithEndpoints("Observer2", "default");

		 ////ShowMessage("comt to registerObservers--4");
		 this->_adapter->activate();

		 ////ShowMessage("comt to registerObservers--5");


		 this->_session->ice_getConnection()->setAdapter(this->_adapter);

//		 registry->ice_getConnection()->setAdapter(this->_adapter);

		 ////ShowMessage("comt to registerObservers--6");

		 _applicationObserverIdentity.name = "application1-" + IceUtil::generateUUID();
		 _applicationObserverIdentity.category = category;
		 _adapterObserverIdentity.name = "adapter1-" + IceUtil::generateUUID();
		 _adapterObserverIdentity.category = category;
		 _objectObserverIdentity.name = "object1-" + IceUtil::generateUUID();
		 _objectObserverIdentity.category = category;
		 _registryObserverIdentity.name = "registry1-" + IceUtil::generateUUID();
		 _registryObserverIdentity.category = category;
		 _nodeObserverIdentity.name = "node1-" + IceUtil::generateUUID();
		 _nodeObserverIdentity.category = category;

		 //MyObjcetObserver *objserver = new MyObjcetObserver(this->LogForm->Memo1);//, this);s
		  ////ShowMessage("comt to registerObservers--7");

		 ApplicationObserverPrx applicationObserver = 
                ApplicationObserverPrx::uncheckedCast(
                    this->_adapter->add(
						new ApplicationObserverI(this->LogForm->Memo1), this->_applicationObserverIdentity));

		AdapterObserverPrx adapterObserver = 
                AdapterObserverPrx::uncheckedCast(
					this->_adapter->add(
						new AdapterObserverI(this->LogForm->Memo1), this->_adapterObserverIdentity));

    	RegistryObserverPrx registryObserver =
                RegistryObserverPrx::uncheckedCast(
                    this->_adapter->add(
                        new RegistryObserverI(this->LogForm->Memo1), this->_registryObserverIdentity));

         ObjectObserverPrx objectObserver = 
                ObjectObserverPrx::uncheckedCast(
                    this->_adapter->add(
						new MyObjcetObserver(this->LogForm->Memo1), this->_objectObserverIdentity));

		 NodeObserverPrx nodeObserver =
                NodeObserverPrx::uncheckedCast(
                    this->_adapter->add(
						new NodeObserverI(this->LogForm->Memo1), this->_nodeObserverIdentity));

//		 this->_session->setObservers(registryObserver,nodeObserver,applicationObserver, adapterObserver, objectObserver);
		  ShowMessage("comt to registerObservers--8");


		/////////////////////blocked here////////////////////////  
		this->_session->setObserversByIdentity(
                        _registryObserverIdentity,
						_nodeObserverIdentity,
                        _applicationObserverIdentity,
						_adapterObserverIdentity,
						_objectObserverIdentity);

//    	this->_session->setObserversByIdentity(
//						Ice::Identity(),
//						Ice::Identity(),
//						Ice::Identity(),
//						_adapterObserverIdentity,
//						Ice::Identity());
		
		 ShowMessage("comt to registerObservers--9");
						  
	}catch(const Ice::LocalException &ex){
    	return false;
	}catch (const IceUtil::Exception & ex){
    	return false;
	}catch (...){
    	return false;
	}
	
	return true;
}

bool MyAdminSession::LogOut()
{
	if( this->_adapter != NULL ){
    	try
                {
                    _adapter->remove(_applicationObserverIdentity);
                }
				catch(Ice::NotRegisteredException e)
				{
				}

				try
				{
					_adapter->remove(_adapterObserverIdentity);
				}
				catch(Ice::NotRegisteredException &e)
				{
				}

				try
				{
					_adapter->remove(_objectObserverIdentity);
				}
				catch(Ice::NotRegisteredException &e)
                {
                }
                
                try
                {
					_adapter->remove(_registryObserverIdentity);
                }
				catch(Ice::NotRegisteredException &e)
				{
				}

				try
				{
					_adapter->remove(_nodeObserverIdentity);
				}
                catch(Ice::NotRegisteredException &e)
                {
				}

		this->_session->destroy();
	}

	return true;
	
}

