//---------------------------------------------------------------------------

#ifndef MyAdminSessionH
#define MyAdminSessionH
//---------------------------------------------------------------------------

#include "Unit1.h"

#include <Ice/Ice.h>
#include <Ice/Current.h>                // for Current
//#include <Ice/DispatchInterceptor.h>    // for DispatchInterceptor, etc
#include <Ice/LocalException.h>         // for AlreadyRegisteredException, etc
#include <Ice/Object.h>                 // for DispatchStatus, Object, etc
#include <Ice/ObjectAdapter.h>          // for ObjectAdapterPtr, etc
#include <Ice/ProxyHandle.h>            // for ProxyHandle
#include <IceGrid/Admin.h>              // for AdminPrx, Admin
#include <IceUtil/Thread.h>             // for ThreadControl
#include <IceUtil/Time.h>               // for Time
#include <IceGrid/Registry.h>

#include <IceGrid/Locator.h>


class MyAdminSession
{
	public:
		MyAdminSession(TForm1 *frm);
		~MyAdminSession();

		bool LogIn(AnsiString username, AnsiString password, AnsiString endpoint);

		bool LogOut();

	protected:
		bool destroyCommunicator();

		bool registerObservers();

	private:

    	long _keepaliveperiod;

		AnsiString _username;
		AnsiString _password;
		AnsiString _endpoint;
		
		TForm1 *LogForm;

		Ice::CommunicatorPtr _communicator;

		Ice::ObjectAdapterPtr _adapter;

		IceGrid::AdminSessionPrx _session;
		IceGrid::AdminPrx _admin;

		Ice::Identity _applicationObserverIdentity;

		Ice::Identity _adapterObserverIdentity   ;

		Ice::Identity _objectObserverIdentity    ;

		Ice::Identity _registryObserverIdentity ;

		Ice::Identity _nodeObserverIdentity ;

		IceGrid::RegistryPrx registry;

		IceGrid::LocatorPrx defaultLocator;

};


#endif
