//---------------------------------------------------------------------------


#pragma hdrstop

#include "MyObjcetObserver.h"

//---------------------------------------------------------------------------



#pragma package(smart_init)

MyObjcetObserver::MyObjcetObserver(TMemo *memo)
//, IceManagerClient *client)
{
	this->LogMemo = memo;
   //	this->managerclient = client;
}


void MyObjcetObserver::objectInit(const ::IceGrid::ObjectInfoSeq& objSeq, const ::Ice::Current& )
{
 	this->LogMemo->Lines->Add( "objectInit" );
}
void MyObjcetObserver::objectAdded(const ::IceGrid::ObjectInfo& objInfo, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add( "objectAdded" +  AnsiString(objInfo.proxy->ice_getIdentity().name.c_str()) ) ;
	
}
void MyObjcetObserver::objectUpdated(const ::IceGrid::ObjectInfo& objInfo, const ::Ice::Current& )
{
   this->LogMemo->Lines->Add( "objectUpdated" +  AnsiString(objInfo.proxy->ice_getIdentity().name.c_str()) ) ;
}
void MyObjcetObserver::objectRemoved(const ::Ice::Identity& objIdentity, const ::Ice::Current& )
{
   this->LogMemo->Lines->Add( "objectRemoved" +  AnsiString(objIdentity.name.c_str()) ) ;
}


NodeObserverI::NodeObserverI(TMemo *memo )//
//, IceManagerClient *client)
{
	this->LogMemo = memo;
	//this->managerclient = client;
}


void NodeObserverI::nodeInit(const NodeDynamicInfoSeq& info, const Ice::Current& current)
{
 	this->LogMemo->Lines->Add("   nodeInit");

}

void NodeObserverI::nodeUp(const NodeDynamicInfo& info, const Ice::Current& current)
{
 	this->LogMemo->Lines->Add("   nodeUp");

}


void NodeObserverI::nodeDown(const string& name, const Ice::Current& current)
{
 	this->LogMemo->Lines->Add("   nodeDown");

}


void NodeObserverI::updateServer(const string& node, const ServerDynamicInfo& info, const Ice::Current& current)
{
 	this->LogMemo->Lines->Add("   updateServer");

}


void NodeObserverI::updateAdapter(const string& node, const AdapterDynamicInfo& info, const Ice::Current& current)
{
 	this->LogMemo->Lines->Add("   updateAdapter");

}

ApplicationObserverI::ApplicationObserverI(TMemo *memo)
{
    this->LogMemo = memo;
}

void ApplicationObserverI::applicationInit(::Ice::Int, const ::IceGrid::ApplicationInfoSeq&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   applicationInit");
}
void ApplicationObserverI::applicationAdded(::Ice::Int, const ::IceGrid::ApplicationInfo&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   applicationAdded");
}
void ApplicationObserverI::applicationRemoved(::Ice::Int, const ::std::string&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   applicationRemoved");
}
void ApplicationObserverI::applicationUpdated(::Ice::Int, const ::IceGrid::ApplicationUpdateInfo&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   applicationUpdated");
}

//
//void ApplicationObserverI::applicationInit(int serial,ApplicationInfoSeq &applications, const Ice::Current& current)
//{
//	this->LogMemo->Lines->Add("   applicationInit");
//}
//void ApplicationObserverI::applicationAdded(int serial, ApplicationInfo &desc, const Ice::Current& current)
//{
//	this->LogMemo->Lines->Add("   applicationAdded");
//}
//void ApplicationObserverI::applicationRemoved(int serial, string &name, const Ice::Current& current)
//{
//    this->LogMemo->Lines->Add("   applicationRemoved");
//}
//void ApplicationObserverI::applicationUpdated(int serial,ApplicationUpdateInfo &desc, const Ice::Current& current)
//{
//	this->LogMemo->Lines->Add("   applicationUpdated");
//}


AdapterObserverI::AdapterObserverI(TMemo *memo)
{
	this->LogMemo = memo;
}
void AdapterObserverI::adapterInit(const ::IceGrid::AdapterInfoSeq&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   adapterInit");
}
void AdapterObserverI::adapterAdded(const ::IceGrid::AdapterInfo&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   adapterAdded");
}
void AdapterObserverI::adapterUpdated(const ::IceGrid::AdapterInfo&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   adapterUpdated");
}
void AdapterObserverI::adapterRemoved(const ::std::string&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   adapterRemoved");
}

RegistryObserverI::RegistryObserverI(TMemo *memo)
{
	this->LogMemo = memo;
}
	
void RegistryObserverI::registryInit(const ::IceGrid::RegistryInfoSeq&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   registryInit");
}
void RegistryObserverI::registryUp(const ::IceGrid::RegistryInfo&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   registryUp");
}
void RegistryObserverI::registryDown(const ::std::string&, const ::Ice::Current& )
{
	this->LogMemo->Lines->Add("   registryDown");
}



