//---------------------------------------------------------------------------

#ifndef MyObjcetObserverH
#define MyObjcetObserverH
//---------------------------------------------------------------------------
 #include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <IceGrid/Observer.h>
#include <Ice/Ice.h>
#include <IceGrid/Registry.h>
#include <IceGrid/Query.h>
#include <IceGrid/Session.h>
#include <IceGrid/Admin.h>
#include <IceGrid/Observer.h>
#include <Glacier2/Router.h>

//#include "icemanager.h"
using namespace  IceGrid;
using namespace Ice;

using namespace std;


class MyObjcetObserver :
		virtual public IceGrid::ObjectObserver
	{
    public:
		//MyObjcetObserver(TMemo *memo, IceManagerClient *client);
		MyObjcetObserver(TMemo *memo);

        // inherited from ObjectObserver
		void objectInit(const ::IceGrid::ObjectInfoSeq& objSeq, const ::Ice::Current& = ::Ice::Current())  ;
		void objectAdded(const ::IceGrid::ObjectInfo& objInfo, const ::Ice::Current& = ::Ice::Current())  ;
		void objectUpdated(const ::IceGrid::ObjectInfo& objInfo, const ::Ice::Current& = ::Ice::Current())  ;
        void objectRemoved(const ::Ice::Identity& objIdentity, const ::Ice::Current& = ::Ice::Current())  ;

    private:
		//IceManagerClient *managerclient;
		TMemo *LogMemo;
	};

class NodeObserverI : public NodeObserver  //, public ObserverBase
{
public:

	NodeObserverI(TMemo *memo);//, IceManagerClient *client);

	virtual void nodeInit(const NodeDynamicInfoSeq& info, const Ice::Current& current= ::Ice::Current());

	virtual void nodeUp(const NodeDynamicInfo& info, const Ice::Current& current= ::Ice::Current())  ;

	virtual void nodeDown(const string& name, const Ice::Current& current= ::Ice::Current())  ;

	virtual void updateServer(const string& node, const ServerDynamicInfo& info, const Ice::Current& current= ::Ice::Current()) ;

	virtual void updateAdapter(const string& node, const AdapterDynamicInfo& info, const Ice::Current& current= ::Ice::Current());

private:

	//IceManagerClient *managerclient;
		TMemo *LogMemo;

};

class ApplicationObserverI : public ApplicationObserver
{
public:
	ApplicationObserverI(TMemo *memo);
	void applicationInit(::Ice::Int, const ::IceGrid::ApplicationInfoSeq&, const ::Ice::Current& = ::Ice::Current());
	void applicationAdded(::Ice::Int, const ::IceGrid::ApplicationInfo&, const ::Ice::Current& = ::Ice::Current());
	void applicationRemoved(::Ice::Int, const ::std::string&, const ::Ice::Current& = ::Ice::Current());
	void applicationUpdated(::Ice::Int, const ::IceGrid::ApplicationUpdateInfo&, const ::Ice::Current& = ::Ice::Current()); 

private:

	TMemo *LogMemo;
};

class AdapterObserverI : public AdapterObserver
{
public:
	AdapterObserverI(TMemo *memo);
	void adapterInit(const ::IceGrid::AdapterInfoSeq&, const ::Ice::Current& = ::Ice::Current());
	void adapterAdded(const ::IceGrid::AdapterInfo&, const ::Ice::Current& = ::Ice::Current());
	void adapterUpdated(const ::IceGrid::AdapterInfo&, const ::Ice::Current& = ::Ice::Current());
	void adapterRemoved(const ::std::string&, const ::Ice::Current& = ::Ice::Current());
private:

	TMemo *LogMemo;
};

class RegistryObserverI : public RegistryObserver
{

public:
	RegistryObserverI(TMemo *memo);
	
	void registryInit(const ::IceGrid::RegistryInfoSeq&, const ::Ice::Current& = ::Ice::Current()) ;
	void registryUp(const ::IceGrid::RegistryInfo&, const ::Ice::Current& = ::Ice::Current()) ;
	void  registryDown(const ::std::string&, const ::Ice::Current& = ::Ice::Current());

private:

	TMemo *LogMemo;
};

typedef IceUtil::Handle<NodeObserverI> NodeObserverIPtr;

#endif
